declare type DirtyDate = Date | number;
export declare const formatDate: (c: Date, b: string, a?: any) => string;
export declare const getStartOfWeek: (b: Date, a?: any) => Date;
export declare const getEndOfWeek: (a: Date) => Date;
export declare const getStartOfMonth: (a: Date) => Date;
export declare const getEndOfMonth: (a: Date) => Date;
export declare const isSameYear: (b?: Date, a?: Date) => boolean;
export declare const isSameMonth: (b?: Date, a?: Date) => boolean;
export declare const isSameDay: (b?: Date, a?: Date) => boolean;
export declare const isDayInRange: (c: Date, b: Date, a: Date) => boolean;
export declare const isStartOfMonth: (a: Date) => boolean;
export declare const isEndOfMonth: (a: Date) => boolean;
export declare const getWeekdayMinInLocale: (b: Date, a: any) => string;
export declare const getWeekdayInLocale: (b: Date, a: any) => string;
export declare const getMonthInLocale: (b: number, a: any) => string;
export declare const getQuarterInLocale: (b: number, a: any) => string;
export declare const isDayDisabled: (b: Date, a: {
    minDate?: Date;
    maxDate?: Date;
    excludeDates?: Date[];
    includeDates?: Date[];
    filterDate?: (day: Date) => boolean;
}) => boolean;
export declare const isOutOfBounds: (b: Date, a: {
    minDate?: Date;
    maxDate?: Date;
}) => boolean;
export declare const monthDisabledBefore: (b: Date, a: {
    minDate?: Date;
    includeDates?: Date[];
}) => boolean;
export declare const monthDisabledAfter: (b: Date, a: {
    maxDate?: Date;
    includeDates?: Date[];
}) => boolean;
export declare const getEffectiveMinDate: (a: {
    minDate?: Date;
    includeDates?: Date[];
}) => Date;
export declare const getEffectiveMaxDate: (a: {
    maxDate?: Date;
    includeDates?: Date[];
}) => Date;
export declare const applyTimeToDate: (b: Date, a: Date) => Date;
export declare const applyDateToTime: (b: Date, a: Date) => Date;
export declare const setSeconds: (dirtyDate: DirtyDate, number: number) => Date;
export declare const setMinutes: (dirtyDate: DirtyDate, number: number) => Date;
export declare const setHours: (dirtyDate: DirtyDate, number: number) => Date;
export declare const setMonth: (dirtyDate: DirtyDate, number: number) => Date;
export declare const setYear: (dirtyDate: DirtyDate, number: number) => Date;
export declare const getMinutes: (dirtyDate: DirtyDate) => number;
export declare const getHours: (dirtyDate: DirtyDate) => number;
export declare const getDate: (dirtyDate: DirtyDate) => number;
export declare const getMonth: (dirtyDate: DirtyDate) => number;
export declare const getYear: (dirtyDate: DirtyDate) => number;
export declare const addDays: (dirtyDate: DirtyDate, number: number) => Date;
export declare const addWeeks: (dirtyDate: DirtyDate, number: number) => Date;
export declare const addMonths: (dirtyDate: DirtyDate, number: number) => Date;
export declare const addYears: (dirtyDate: DirtyDate, number: number) => Date;
export declare const subDays: (dirtyDate: DirtyDate, number: number) => Date;
export declare const subWeeks: (dirtyDate: DirtyDate, number: number) => Date;
export declare const subMonths: (dirtyDate: DirtyDate, number: number) => Date;
export declare const subYears: (dirtyDate: DirtyDate, number: number) => Date;
export declare const isBefore: (fromDirty: DirtyDate, toDirty: DirtyDate) => boolean;
export declare const isAfter: (fromDirty: DirtyDate, toDirty: DirtyDate) => boolean;
export declare const format: (date: Date, format: string, locale?: any | null) => string;
export {};
