/*
Copyright (c) Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
import { styled } from '../styles';
import { getInputStyles, getInputContainerStyles, getRootStyles } from '../input/styled-components';
export const StyledTextAreaRoot = styled('div', props => {
  return { ...getRootStyles({
      $positive: false,
      ...props,
      $hasIconTrailing: false
    }),
    width: props.$resize ? 'fit-content' : '100%'
  };
});
StyledTextAreaRoot.displayName = "StyledTextAreaRoot";
StyledTextAreaRoot.displayName = 'StyledTextAreaRoot';
export const StyledTextareaContainer = styled('div', props => {
  return getInputContainerStyles({
    $positive: false,
    ...props
  });
});
StyledTextareaContainer.displayName = "StyledTextareaContainer";
StyledTextareaContainer.displayName = 'StyledTextareaContainer';
export const StyledTextarea = styled('textarea', props => {
  return { ...getInputStyles(props),
    resize: props.$resize || 'none'
  };
});
StyledTextarea.displayName = "StyledTextarea";
StyledTextarea.displayName = 'StyledTextarea';