import type * as React from 'react';
import type { Override } from '../helpers/overrides';
import type { DURATION, PLACEMENT } from './constants';
export declare type Duration = typeof DURATION.infinite | typeof DURATION.short | typeof DURATION.medium | typeof DURATION.long;
export declare type Placement = typeof PLACEMENT.topLeft | typeof PLACEMENT.top | typeof PLACEMENT.topRight | typeof PLACEMENT.bottomLeft | typeof PLACEMENT.bottom | typeof PLACEMENT.bottomRight;
export declare type SnackbarElementOverrides = {
    Root?: Override;
    Content?: Override;
    StartEnhancerContainer?: Override;
    Spinner?: Override;
    Message?: Override;
    WrapActionButtonContainer?: Override;
    ActionButtonContainer?: Override;
};
export declare type SnackbarElementProps = {
    actionMessage?: string;
    actionOnClick?: (a: React.SyntheticEvent<HTMLButtonElement>) => unknown;
    focus?: boolean;
    message: React.ReactNode;
    overrides?: SnackbarElementOverrides;
    progress?: boolean;
    startEnhancer?: React.ComponentType<{
        size: number;
    }>;
};
export declare type SnackbarProviderProps = {
    children?: React.ReactNode;
    overrides?: {
        PlacementContainer?: Override;
    } & SnackbarElementOverrides;
    placement?: Placement;
    defaultDuration?: Duration;
};
