"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LightTheme = void 0;

var _colorTokens = _interopRequireDefault(require("./color-tokens"));

var _colorSemanticTokens = _interopRequireDefault(require("./color-semantic-tokens"));

var _colorComponentTokens = _interopRequireDefault(require("./color-component-tokens"));

var _borders = _interopRequireDefault(require("../shared/borders"));

var _lighting = _interopRequireDefault(require("../shared/lighting"));

var _typography = _interopRequireDefault(require("../shared/typography"));

var _animation = _interopRequireDefault(require("../shared/animation"));

var _breakpoints = _interopRequireDefault(require("../shared/breakpoints"));

var _grid = _interopRequireDefault(require("../shared/grid"));

var _mediaQuery = _interopRequireDefault(require("../shared/media-query"));

var _sizing = _interopRequireDefault(require("../shared/sizing"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var LightTheme = {
  name: 'light-theme',
  colors: _objectSpread(_objectSpread(_objectSpread({}, _colorTokens.default), (0, _colorComponentTokens.default)()), (0, _colorSemanticTokens.default)()),
  animation: _animation.default,
  breakpoints: _breakpoints.default,
  borders: _borders.default,
  direction: 'auto',
  grid: _grid.default,
  lighting: _lighting.default,
  mediaQuery: _mediaQuery.default,
  sizing: _sizing.default,
  typography: (0, _typography.default)(),
  // TODO(#2318) Remove it in the next v11 major version.
  // Do not use.
  zIndex: {
    modal: 2000
  }
};
exports.LightTheme = LightTheme;